Index: palm/trunk/SOURCE/surface_data_output_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_data_output_mod.f90	(revision 4494)
+++ palm/trunk/SOURCE/surface_data_output_mod.f90	(revision 4495)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! restart data handling with MPI-IO added
+! 
+! 4444 2020-03-05 15:59:50Z raasch
 ! bugfix: cpp-directives for serial mode added
 ! 
@@ -108,5 +111,5 @@
    USE control_parameters,                                                     &
        ONLY:  coupling_char, data_output_during_spinup, end_time,              &
-              message_string, run_description_header, simulated_time_at_begin, &
+              message_string, restart_data_format_output, run_description_header, simulated_time_at_begin, &
               spinup_time, surface_output
 
@@ -130,4 +133,7 @@
 
    USE pegrid
+
+   USE restart_data_mpi_io_mod,                                                                    &
+       ONLY:  rrd_mpi_io, wrd_mpi_io
 
    USE surface_mod,                                                            &
@@ -237,5 +243,6 @@
 
    INTERFACE  surface_data_output_rrd_global
-      MODULE PROCEDURE surface_data_output_rrd_global
+      MODULE PROCEDURE surface_data_output_rrd_global_ftn
+      MODULE PROCEDURE surface_data_output_rrd_global_mpi
    END INTERFACE  surface_data_output_rrd_global
 
@@ -4507,10 +4514,11 @@
     END SUBROUTINE surface_data_output_last_action
 
+
 !------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> This routine reads globally used restart data.
+!> Read module-specific global restart data (Fortran binary format).
 !------------------------------------------------------------------------------!
-    SUBROUTINE surface_data_output_rrd_global( found )
+    SUBROUTINE surface_data_output_rrd_global_ftn( found )
 
 
@@ -4536,5 +4544,18 @@
 
 
-    END SUBROUTINE surface_data_output_rrd_global
+    END SUBROUTINE surface_data_output_rrd_global_ftn
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Read module-specific global restart data (MPI-IO).
+!------------------------------------------------------------------------------!
+    SUBROUTINE surface_data_output_rrd_global_mpi
+
+       CALL rrd_mpi_io( 'average_count_surf', average_count_surf )
+
+    END SUBROUTINE surface_data_output_rrd_global_mpi
+
 
 !------------------------------------------------------------------------------!
@@ -4581,6 +4602,14 @@
        IMPLICIT NONE
 
-       CALL wrd_write_string( 'average_count_surf' )
-       WRITE ( 14 )  average_count_surf
+       IF ( TRIM( restart_data_format_output ) == 'fortran_binary' )  THEN
+
+          CALL wrd_write_string( 'average_count_surf' )
+          WRITE ( 14 )  average_count_surf
+
+       ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+
+         CALL wrd_mpi_io( 'average_count_surf', average_count_surf )
+
+       ENDIF
 
     END SUBROUTINE surface_data_output_wrd_global
@@ -4595,9 +4624,16 @@
        IMPLICIT NONE
 
-         IF ( ALLOCATED( surfaces%var_av ) )  THEN
-            CALL wrd_write_string( 'surfaces%var_av' )
-            WRITE ( 14 )  surfaces%var_av
-         ENDIF
-
+       IF ( TRIM( restart_data_format_output ) == 'fortran_binary' )  THEN
+
+          IF ( ALLOCATED( surfaces%var_av ) )  THEN
+             CALL wrd_write_string( 'surfaces%var_av' )
+             WRITE ( 14 )  surfaces%var_av
+          ENDIF
+
+       ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+
+          IF ( ALLOCATED( surfaces%var_av ) )  CALL wrd_mpi_io( 'surfaces%var_av', surfaces%var_av )
+
+       ENDIF
 
     END SUBROUTINE surface_data_output_wrd_local
Index: palm/trunk/SOURCE/surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_mod.f90	(revision 4494)
+++ palm/trunk/SOURCE/surface_mod.f90	(revision 4495)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! restart data handling with MPI-IO added
+! 
+! 4366 2020-01-09 08:12:43Z raasch
 ! workaround implemented to avoid vectorization bug on NEC Aurora
 ! 
@@ -138,4 +141,7 @@
         ONLY:  rif1d, us1d, usws1d, vsws1d
 
+    USE restart_data_mpi_io_mod,                                                                   &
+        ONLY:  rd_mpi_io_surface_filetypes, total_number_of_surface_values, wrd_mpi_io,            &
+               wrd_mpi_io_global_array, wrd_mpi_io_surface
 
     IMPLICIT NONE
@@ -2980,4 +2986,8 @@
        INTEGER(iwp), DIMENSION(0:3) ::  mm            !< running index for surface elements on gathered surface array
        INTEGER(iwp), DIMENSION(0:3) ::  start_index_v !< start index for vertical surface elements on gathered surface array
+
+       INTEGER(iwp),DIMENSION(nys:nyn,nxl:nxr) ::  global_start_index  !< index for surface data (MPI-IO)
+
+       LOGICAL ::  surface_data_to_write  !< switch for MPI-I/O if PE has surface data to write
 
        TYPE(surf_type), DIMENSION(0:2) ::  surf_h     !< gathered horizontal surfaces, contains all surface types
@@ -3165,5 +3175,5 @@
                       IF ( ALLOCATED( surf_usm_h%pt_surface ) )                &
                          surf_h(l)%pt_surface(mm(l)) = surf_usm_h%pt_surface(m)
-                       IF ( ALLOCATED( surf_usm_h%q_surface ) )                &
+                      IF ( ALLOCATED( surf_usm_h%q_surface ) )                 &
                          surf_h(l)%q_surface(mm(l)) = surf_usm_h%q_surface(m)
                       IF ( ALLOCATED( surf_usm_h%vpt_surface ) )               &
